/*!
 * global-websocket-client v1.0.3 - https://github.com/rodrigoramosrs/global-websocket-client
 * MIT Licensed
 */
(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("react"));
	else if(typeof define === 'function' && define.amd)
		define(["react"], factory);
	else if(typeof exports === 'object')
		exports["umd_build"] = factory(require("react"));
	else
		root["umd_build"] = factory(root["React"]);
})(window, function(__WEBPACK_EXTERNAL_MODULE__0__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE__0__;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(5);


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (false) { var throwOnDirectAccess, ReactIs; } else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = __webpack_require__(3)();
}


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */



var ReactPropTypesSecret = __webpack_require__(4);

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

module.exports = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  };
  shim.isRequired = shim;
  function getShim() {
    return shim;
  };
  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */



var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

module.exports = ReactPropTypesSecret;


/***/ }),
/* 5 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);

// EXTERNAL MODULE: external {"root":"React","commonjs2":"react","commonjs":"react","amd":"react"}
var external_root_React_commonjs2_react_commonjs_react_amd_react_ = __webpack_require__(0);

// EXTERNAL MODULE: ./node_modules/prop-types/index.js
var prop_types = __webpack_require__(2);

// CONCATENATED MODULE: ./src/Utils/index.js
///Guid Generator
function GenerateGUID() {
  return "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function (c) {
    var r = Math.random() * 16 | 0,
        v = c == "x" ? r : r & 0x3 | 0x8;
    return v.toString(16);
  });
}

///Base 64 Encode/Decode
var chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
var Base64 = {
  btoa: function btoa() {
    var input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

    var str = input;
    var output = "";

    for (var block = 0, charCode, i = 0, map = chars; str.charAt(i | 0) || (map = "=", i % 1); output += map.charAt(63 & block >> 8 - i % 1 * 8)) {
      charCode = str.charCodeAt(i += 3 / 4);

      if (charCode > 0xff) {
        throw new Error("'btoa' failed: The string to be encoded contains characters outside of the Latin1 range.");
      }

      block = block << 8 | charCode;
    }

    return output;
  },

  atob: function atob() {
    var input = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "";

    var str = input.replace(/=+$/, "");
    var output = "";

    if (str.length % 4 == 1) {
      throw new Error("'atob' failed: The string to be decoded is not correctly encoded.");
    }
    for (var bc = 0, bs = 0, buffer, i = 0; buffer = str.charAt(i++); ~buffer && (bs = bc % 4 ? bs * 64 + buffer : buffer, bc++ % 4) ? output += String.fromCharCode(255 & bs >> (-2 * bc & 6)) : 0) {
      buffer = chars.indexOf(buffer);
    }

    return output;
  },

  isBase64: function isBase64(v, opts) {
    if (v instanceof Boolean || typeof v === "boolean") {
      return false;
    }
    if (!(opts instanceof Object)) {
      opts = {};
    }
    if (opts.hasOwnProperty("allowBlank") && !opts.allowBlank && v === "") {
      return false;
    }

    var regex = "(?:[A-Za-z0-9+\\/]{4})*(?:[A-Za-z0-9+\\/]{2}==|[A-Za-z0-9+/]{3}=)?";

    if (opts.mime) {
      regex = "(data:\\w+\\/[a-zA-Z\\+\\-\\.]+;base64,)?" + regex;
    }

    if (opts.paddingRequired === false) {
      regex = "(?:[A-Za-z0-9+\\/]{4})*(?:[A-Za-z0-9+\\/]{2}(==)?|[A-Za-z0-9+\\/]{3}=?)?";
    }

    return new RegExp("^" + regex + "$", "gi").test(v);
  }
};
// CONCATENATED MODULE: ./src/WebSocketClient/index.js
var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

/* global WebSocket */
/* eslint no-unused-vars: "off" */




function NormalizeDataToBase64(data) {
  var message = Object.assign({}, data);

  if ((typeof message === "undefined" ? "undefined" : _typeof(message)) === "object") message = JSON.stringify(message);

  if (!Base64.isBase64(message)) message = Base64.btoa(message);

  return message;
}

var _websocket;
var WebSocketClient = {
  send: function send(data) {
    if (!_websocket) return;

    _websocket.send(data);
  },
  sendAsBase64: function sendAsBase64(data) {
    if (!_websocket) return;
    var message = NormalizeDataToBase64(data);

    _websocket.send(message);
  },
  close: function close() {
    if (!_websocket) return;

    _websocket.close();
    _websocket = undefined;
  },
  isConnected: function isConnected() {
    if (!_websocket) return false;

    return _websocket.readyState === 1;
  },
  getState: function getState() {
    if (!_websocket) return 3;

    return _websocket.readyState;
  },
  connect: function connect(url, openCallback, onErrorCallback, onMessageCallback, onCloseCallback) {
    _websocket = new WebSocket(url);
    _websocket.onopen = function (event) {
      if (openCallback) openCallback(event);
    };
    _websocket.onmessage = function (event) {
      if (onMessageCallback) onMessageCallback(event);
    };
    _websocket.onerror = function (event) {
      if (onErrorCallback) onErrorCallback(event);
    };
    _websocket.onclose = function (event) {
      if (onCloseCallback) onCloseCallback(event);
    };
  }
};

/* harmony default export */ var src_WebSocketClient = (WebSocketClient);
//export default WebSocketClient;
// CONCATENATED MODULE: ./src/MessageBuilder/ContentType.js
var ContentType = {
  APPLICATION_JSON: 0,
  APPLICATION_OCTET_STREAM: 10,
  APPLICATION_BASE64: 20,
  APPLICATION_XML: 30,
  AUDIO_MPEG: 40,
  AUDIO_OGG: 50,
  AUDIO: 60,
  VIDEO_MP4: 70,
  TEXT_PLAIN: 80,
  TEXT_HTML: 90,
  IMAGE_JPEG: 100,
  IMAGE_PNG: 110
};

/* harmony default export */ var MessageBuilder_ContentType = (ContentType);
// CONCATENATED MODULE: ./src/MessageBuilder/ActionType.js
var ActionType = {
  APP_CONNECTED: 0, // Envia um comando informando que o app conectou na sessão
  APP_DISCONNECTED: 1, // Envia um comando informando que o app desconectou  da sessão
  HOST_CONNECTED: 2, // Envia um comando para o app informando que o host conectou
  HOST_DISCONNECTED: 3, // Envia um comando para o app informando que o host desconectou

  STATE_CHANGED: 5, // Envia uma acao remota para informar o novo estado;

  ATALHO_ACAO_LAUDAR: 20, //Comando para executar ação remota (ex. laudar, revisar, assinar)
  ATALHO_ACAO_REVISAR: 21, //Comando para executar ação remota (ex. laudar, revisar, assinar)
  ATALHO_ACAO_LAUDAR_REVISAR: 22, //Comando para executar ação remota (ex. laudar, revisar, assinar)

  RECONHECIMENTO_VOZ_STT: 30, // Comando para enviar o texto reconhecido de um audio STT

  ENVIAR_TEXTO_LAUDO: 40, // Comando para enviar o conteúdo de texto para o editor.

  DITADO_AUDIO: 50, //Comando para enviar Audio Ditado

  PEDIDO_MEDICO_ANEXO: 60, // Comando para enviar Anexo (pedido médico)

  COMANDO_ASSISTENTE: 70 // Comando de texto para enviar uma ação que será interpretada pelo assistente
};

/* harmony default export */ var MessageBuilder_ActionType = (ActionType);
// CONCATENATED MODULE: ./src/MessageBuilder/index.js





var DefaultMessage = {
  CurrentID: undefined,
  RoomID: undefined,
  MessageContent: {
    ActionType: undefined,
    ContentType: undefined,
    ContentValue: undefined
  }
};

function GetDefaultObject() {
  return Object.assign({}, DefaultMessage);
}

var MessageBuilder = {
  AppConnected: function AppConnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.APP_CONNECTED;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  AppDisconected: function AppDisconected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.APP_DISCONNECTED;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  HostConnected: function HostConnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.HOST_CONNECTED;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  HostDisconnected: function HostDisconnected(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.HOST_DISCONNECTED;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  AnexoPedidoMedico: function AnexoPedidoMedico(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.PEDIDO_MEDICO_ANEXO;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_BASE64;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Texto: function Texto(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.ENVIAR_TEXTO_LAUDO;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Audio: function Audio(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.DITADO_AUDIO;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_BASE64;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  StateChanged: function StateChanged(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.STATE_CHANGED;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Laudar: function Laudar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.ATALHO_ACAO_LAUDAR;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  Revisar: function Revisar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.ATALHO_ACAO_REVISAR;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  LaudarRevisar: function LaudarRevisar(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.ATALHO_ACAO_LAUDAR_REVISAR;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  ReconhecimentoSTT: function ReconhecimentoSTT(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.RECONHECIMENTO_VOZ_STT;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.TEXT_PLAIN;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  },
  ComandoAssistente: function ComandoAssistente(content) {
    var returnMessage = GetDefaultObject();
    returnMessage.CurrentID = GenerateGUID();
    returnMessage.RoomID = "";
    returnMessage.MessageContent.ActionType = MessageBuilder_ActionType.COMANDO_ASSISTENTE;
    returnMessage.MessageContent.ContentType = MessageBuilder_ContentType.APPLICATION_JSON;
    returnMessage.MessageContent.ContentValue = content;
    return returnMessage;
  }
};


// CONCATENATED MODULE: ./src/index.js
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "MessageBuilder", function() { return MessageBuilder; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "ActionType", function() { return MessageBuilder_ActionType; });
/* concated harmony reexport */__webpack_require__.d(__webpack_exports__, "ContentType", function() { return MessageBuilder_ContentType; });



/* harmony default export */ var src = __webpack_exports__["default"] = (src_WebSocketClient);


/***/ })
/******/ ])["default"];
});